/*
 *  cuteAjax v0.3
 *
 *  Last modification: 2009-11-07
 *  Copyright (c) 2009
 *  Kieran Menor
 *	kieran at menor dot dk
 *
 *  Do not use without permission.
 */

var cuteAjax = {
	submitForm: function(form, callback) {
		form = this.getElement(form);
		this.request(form.action, callback, this.formToObject(form), form.method);
		return false;		
	},
	request: function(url, callback, data, method) {
		var hash, j, qs, xml;
		xml = this.getObject();
		if(!xml) {
			return false;
		}
		qs = (typeof data == 'object') ? this.objectToQueryString(data) : '';
		if(typeof callback == 'object') {
			xml.onreadystatechange = function() {
				if(callback.state & Math.pow(2, xml.readyState)) {
					callback.callback(xml, callback.args);
				}
			};
		}
		if((typeof method == 'string') && (method.toUpperCase() == 'POST')) {
			xml.open('POST', url, true);
			xml.setRequestHeader('Content-type', 'application/x-www-form-urlencoded; charset=utf-8');
			xml.setRequestHeader('Content-length', qs.length);
			xml.send(qs);
		}
		else {
			if(qs != '') {
				hash = '';
				if((j = url.indexOf('#')) != -1) {
					hash = url.substring(j);
					url = url.substring(0, j);
				}
				url += (url.indexOf('?') == -1) ? '?' : '&';
				url += qs + hash;
			}
			xml.open('GET', url, true);
			xml.send(null);
		}
	},
	parseXml: function(xml) {
		var dom, parser;
		dom = null;
		if(typeof DOMParser != 'undefined') {
			try {
				parser = new DOMParser();
				dom = parser.parseFromString(xml, 'text/xml');
			}
			catch(e1) {
				dom = null;
			}
		}
		if(!dom) {
			try {
				dom = new ActiveXObject('Microsoft.XMLDOM');
				dom.async = false;
				dom.loadXML(xml);
			}
			catch(e2) {
				dom = null;
			}
		}
		return dom;
	},
	formToObject: function(form) {
		var data, ref, key, i, j, k, l;
		form = this.getElement(form);
		data = {};
		if(form && form.elements) {
			for(i = 0; i < form.elements.length; i++) {
				if(((form.elements[i].type == 'select-one') && (form.elements[i].options.length == 0)) || (form.elements[i].type == 'file') || (((form.elements[i].type == 'checkbox') || (form.elements[i].type == 'radio')) && !form.elements[i].checked)) {
					continue;
				}
				ref = data;
				if((j = form.elements[i].name.indexOf('[')) != -1) {
					key = form.elements[i].name.substring(0, j);
					j = 0;
					while(k = this.getBetween(form.elements[i].name, '[', ']', j)) {
						j = k.offset;
						switch(typeof ref[key]) {
							case 'undefined':
								ref[key] = {};
								break;
							case 'string':
							case 'number':
								ref[key] = {0: ref[key]};
						}
						if(k.result == '') {
							continue;
						}
						ref = ref[key];
						key = k.result;
					}
				}
				else {
					key = form.elements[i].name;
				}
				switch(form.elements[i].type) {
					case 'select-one':
						k = [form.elements[i][form.elements[i].selectedIndex].value];
						break;
					case 'select-multiple':
						k = [];
						for(j = 0; j < form.elements[i].options.length; j++) {
							if(form.elements[i].options[j].selected) {
								k[k.length] = form.elements[i].options[j].value;
							}
						}
						break;
					default:
						k = [form.elements[i].value];
				}
				for(j = 0; j < k.length; j++) {
					switch(typeof ref[key]) {
						case 'undefined':
							ref[key] = k[j];
							break;
						case 'string':
						case 'number':
							ref[key] = {0: ref[key], 1: k[j]};
							break;
						case 'object':
							if(ref[key].constructor == Object) {
								l = this.highestIndex(ref[key]);
								ref[key][((typeof l == 'undefined')?0:(l+1))] = k[j];
							}
					}
				}
			}
			return data;
		}
		return false;
	},
	objectToQueryString: function(object) {
		var qs, x;
		if(typeof object == 'object') {
			qs = [];
			for(x in object) {
				this.parsePostData(qs, x, object[x]);
			}
			return qs.join('&');
		}
		return false;
	},
	parsePostData: function(request, name, data) {
		var i, x;
		switch(typeof data) {
			case 'object':
				switch(data.constructor) {
					case Array:
						for(i = 0; i < data.length; i++) {
							this.parsePostData(request, name+'['+i+']', data[i]);
						}
						break;
					case Object:
						for(x in data) {
							this.parsePostData(request, name+'['+x+']', data[x]);
						}
				}
				break;
			case 'number':
			case 'string':
				request[request.length] = name+'='+encodeURIComponent(data);
		}
	},
	getObject: function() {
		var xml, msxml, i;
		xml = null;
		msxml = [
			'Msxml2.XMLHTTP.6.0',
			'Msxml2.XMLHTTP.3.0',
			'Msxml2.XMLHTTP',
			'Microsoft.XMLHTTP'
		];
		if(typeof XMLHttpRequest != 'undefined') {
			try {
				xml = new XMLHttpRequest();
			}
			catch(e1) {
				xml = null;
			}
		}
		if(!xml) {
			for(i = 0; ((i < msxml.length) && (xml === null)); i++) {
				try {
					xml = new ActiveXObject(msxml[i]);
				}
				catch(e2) {
					xml = null;
				}
			}
		}
		return xml;
	},
	getBetween: function(input, start, end, offset) {
		var a, b;
		offset = (typeof offset == 'undefined') ? 0 : parseInt(offset);
		a = input.indexOf(start, offset);
		b = input.indexOf(end, a);
		if((a == -1) || (b == -1)) {
			return false;
		}
		return {result: input.substring(a+1, b), offset: b+1};
	},
	highestIndex: function(array) {
		var i, m;
		for(i in array) {
			if(((typeof i == 'number') || (String(parseInt(i)) === i)) && ((typeof m == 'undefined') || (i > m))) {
				m = parseInt(i);
			}
		}
		return m;
	},
	getElement: function(element) {
		return (typeof element == 'string') ? document.getElementById(element) : element;
	}
};