<?php
header("Content-Type: text/css");

echo "body {
	background: $bg;
	font-family: $font;
}
body, td {
	font-size: 10pt;
	color: #$text;
}
.banner {
	height: 100px;
	background: transparent url($banner) no-repeat scroll top center;
	margin-bottom: 16px;
}


/* Links */

a {
	text-decoration: none;
	font-weight: bold;
	color: #$link;
}
a:visited {
	color: #$vlink;
}
a:hover {
	color: #$hlink;
}
a:active {
	color: #$alink;
}


/* Tables */

td.normal, td.news {
	padding: 3px;
	background: #$cell1;
}
td.line {
	background-color: #$cellc;
	height: 3px;
}
td.head, td.title{
	font-weight: bold;
	background: #$cellh;
	padding: 3px;
}
td.cell2, td.rope {
	background: #$cell2;
}
td.cat, td.cell3 {
	background: #$cellc;
	padding: 3px;
}


/* Content and footer */

div#container {
	margin-$menu_float: 178px;
}


/* Menu */

div#menu {
	width: 162px;
	float: $menu_float;
}
div#menu div#header {
	text-align: center;
	font-weight: bold;
	background: #$cellh;
	padding: 3px;
}
div#menu div#items {
	padding: 3px;
	background: #$cell2;
}
div#menu div#items span.menu_icon {
	background: transparent url($menu_icon) no-repeat scroll top center;
}";
?>
/*******************************************************/

/* General other */

img {
	border: 0;
}
hr {
	height: 1px;
	border: 0;
	background-color: #FFFFFF;
	color: #FFFFFF;
}
div#footer {
	font-size: 6pt;
	text-align: center;
}
div#content {
	margin-bottom: 16px;
}


/* IE hack */

* html div#container {
    height: 1%;
}


/* General table classes */

table.brdr, table.top {
	width: 100%;
	border-collapse: collapse;
}
td.shot {
	padding-top: 2px;
	padding-bottom: 2px;
}
td.pad {
	padding-top: 3px;
	padding-bottom: 3px;
	padding-left: 5px;
	padding-right: 5px;
}
td.bborder {
	border-bottom: 1px solid #000000;
}
td.text {
	padding: 3px;
}
td.space {
	height: 16px;
}
td.vspace {
	width: 16px;
}


/* Quote and code boxes */

div.quote {
	margin-left: 40px;
	margin-right: 40px;
}
div.quote span.boxhead {
	font-size: 11px;
}
div.quote div.box {
	margin-top: 2px;
	padding: 3px;
	border: 1px solid #000000;
}
div.code {
	margin-left: 40px;
	margin-right: 40px;
}
div.code span.boxhead {
	font-size: 11px;
	color: #00FF00;
}
div.code div.box {
	margin-top: 2px;
	padding: 3px;
	white-space: pre;
	border: 1px solid #00FF00;
	color: #00FF00;
}


/* General formatting classes */

.border {
	border: 1px solid #000000;
}
.nuborder {
	border-left: 1px solid #000000;
	border-right: 1px solid #000000;
	border-bottom: 1px solid #000000;
}
.nowrap {
	white-space: nowrap;
}
.center	{
	text-align: center;
}
.right {
	text-align: right;
}
.selected {
	text-decoration: underline;
}
.admin {
	color: #FFCC66;
}
.user {
	color: #DDBBFF;
}
.gray {
	color: #999999;
}
.warning {
	color: #FF0000;
}
.new {
	font-weight: bold;
	color: #FFFF00;
}
.off {
	font-weight: bold;
	color: #CCCCCC;
}