/*
 *  rotator v0.1
 *  Copyright (c) 2009
 *  Kieran Menor
 *	kieran at menor dot dk
 *
 *  Do not use without permission.
 */

var rotator = {
	rotator: function(list) {
		if(this.constructor == rotator.rotator) {
			this.index = rotator.index.length;
			rotator.index[this.index] = this;
			this.rotating = false;
			this.div = document.createElement('div');
			this.div.style.overflow = 'hidden';
			this.div.style.textAlign = 'center';
			this.div.style.width = '100%';
			this.div.onmousemove = (function(self) {
				return function(e) {
					if(!e) {
						var e = window.event;
					}
					self.handleMouse(e, self);
				};
			})(this);
			this.span = document.createElement('span');
			this.span.style.whiteSpace = 'nowrap';
			this.span.style.position = 'relative';
			this.span.style.left = '0px';
			this.div.appendChild(this.span);
			this.images = [];
			for(var i = 0; i < list.length; i++) {
				this.images[i] = document.createElement('img');
				this.images[i].src = list[i];
				this.images[i].style.margin = '0 3px';
				this.span.appendChild(this.images[i]);
			}
		}
		else {
			alert('Can\'t call method in non-object context.');
		}
	},
	index: []
};
rotator.rotator.prototype.getOffset = function() {
	var x = 0;
	var element = this.div;
	do {
		x += element.offsetLeft;
	} while((element = element.offsetParent) != document.body);
	return x;
}
rotator.rotator.prototype.appendTo = function(element) {
	if(typeof element == 'string') {
		element = document.getElementById(element);
	}
	element.appendChild(this.div);
};
rotator.rotator.prototype.handleMouse = function(e, self) {
	if(self.span.offsetWidth <= self.div.offsetWidth) {
		self.rotateTo = 0;
		if(!this.rotating && (parseInt(this.span.style.left) != self.rotateTo)) {
			this.rotating = true;
			self.rotate();
		}
	}
	else {
		var x = e.clientX || e.pageX;
		var w = self.span.offsetWidth-self.div.offsetWidth;
		var pos = -((x-50-self.getOffset())/(self.div.offsetWidth-100)*w);
		if(pos > 0) {
			pos = 0;
		}
		if(pos < -(w)) {
			pos = -(w);
		}
		self.rotateTo = pos;
		if(!this.rotating && (parseInt(this.span.style.left) != self.rotateTo)) {
			this.rotating = true;
			self.rotate();
		}
	}
};
rotator.rotator.prototype.rotate = function() {
	var step = (this.rotateTo-parseInt(this.span.style.left))/8;
	this.span.style.left = Math.floor(parseInt(this.span.style.left)+step)+'px';
	if(parseInt(this.span.style.left) != this.rotateTo) {
		setTimeout('rotator.index['+this.index+'].rotate()', 20);
	}
	else {
		this.rotating = false;
	}
};